//BBC TICKER WIDGET VERSION 1.2

var gDoneButton; 
var gInfoButton; 

// global request and XML document objects
var req;

//MAIN TICKER FUNCTION
//SET PREFERENCE VARIABLES
var myTimer;
var theCharacterTimeout = 50;
var theStoryTimeout = 5000;
// Ticker startup function
function startTicker() {
	//clear the ticker timer
	window.clearTimeout(myTimer);
	// Define run time values
	//Feed Name
	document.getElementById("whichFeed").innerHTML = '<a href="' + req.responseXML.getElementsByTagName("link")[0].firstChild.nodeValue + '">' + req.responseXML.getElementsByTagName("title")[0].firstChild.nodeValue + '<\/a>';
	//Feed Date
	document.getElementById("feedDate").innerHTML = req.responseXML.getElementsByTagName("lastBuildDate")[0].firstChild.nodeValue;
	//Get the Items array
	items = req.responseXML.getElementsByTagName("item");
	theItemCount = items.length;
	theCurrentStory = -1;
	theCurrentLength = 0;
	// Locate base objects
	if (document.getElementById) {
			//Write the anchor text for the ticker
			document.getElementById("details").innerHTML = '<h3><a id="tickerAnchor" href="#" onclick="clicked(this.href);return false;"><\/a><\/h3><p><span id="tickerStory"><\/span><\/p>';
			theAnchorObject = document.getElementById("tickerAnchor");
			theStoryObject = document.getElementById("tickerStory");
			runTheTicker();
		} else {
			return true;
	}
}

// Ticker main run loop function
function runTheTicker() {
	var myTimeout;
	// Go for the next story data block
	if(theCurrentLength == 0) {
		theCurrentStory++;
		theCurrentStory = theCurrentStory % theItemCount;
		
		theStoryHeader = getElementTextNS("", "title", items[theCurrentStory], 0);
		theStorySummary = getElementTextNS("", "description", items[theCurrentStory], 0);
		theTargetLink = getElementTextNS("", "link", items[theCurrentStory], 0);

		theAnchorObject.innerHTML = theStoryHeader;
		theAnchorObject.href = theTargetLink;

	}
	// Stuff the current ticker text into the anchor
	theStoryObject.innerHTML = theStorySummary.substring(0,theCurrentLength);
	// Modify the length for the substring and define the timer
	if(theCurrentLength < theStorySummary.length) {
		theCurrentLength++;
		myTimeout = theCharacterTimeout;
	} else {
		theCurrentLength = 0;
		myTimeout = theStoryTimeout;
	}
	// Call up the next cycle of the ticker
	myTimer = window.setTimeout("runTheTicker()", myTimeout);
}

// retrieve XML document (reusable generic function);
function loadXMLDoc(url) {
	// Display loading flag
	startLoadFlag();
	// branch for native XMLHttpRequest object
	if (window.XMLHttpRequest) {
		req = new XMLHttpRequest();
		req.onreadystatechange = processReqChange;
		req.open("GET", url, true);
		req.send(null);
	}
}

// handle onreadystatechange event of req object
function processReqChange() {
	// only if req shows "loaded"
	if (req.readyState == 4) {
		// only if "OK"
		if (req.status == 200) {
			stopLoadFlag();
			startTicker();
		} else {
			// Stop displaying loading flag
			stopLoadFlag();
			document.getElementById('details').innerHTML = '<p>Unable to download news feed from the BBC website.<\/p>';
		}
	}
}

// DISPLAY LOADING ANIMATION
function startLoadFlag() {
	document.getElementById('details').innerHTML = '<p id="LoadMsg"><img src="g/loadani.gif" alt="" width="50" height="50" /><\/p>';
}

// HIDE LOADING ANIMATION
function stopLoadFlag() {
	document.getElementById('details').innerHTML = "";
}


//get the content to show
function show() {
	if(window.widget && widget.preferenceForKey("newsFeed")) {
	alert('hello')
		//loadXMLDoc('http://newsrss.bbc.co.uk/rss/newsonline_uk_edition/' + document.getElementById('categs').options[1].value + '/rss.xml');
		loadXMLDoc('http://newsrss.bbc.co.uk/rss/newsonline_uk_edition/' + document.getElementById('categs').options[widget.preferenceForKey("newsFeed")].value + '/rss.xml');
	} else {
		loadXMLDoc('http://newsrss.bbc.co.uk/rss/newsonline_uk_edition/' + document.getElementById('categs').options[0].value + '/rss.xml');
	}
}

// retrieve text of an XML document element, including
// elements using namespaces
function getElementTextNS(prefix, local, parentElem, index) {
	var result = "";
	result = parentElem.getElementsByTagName(local)[index];
	if (result) {
		// get text, accounting for possible
		// whitespace (carriage return) text nodes
		if (result.childNodes.length > 1) {
			return result.childNodes[1].nodeValue;
		} else {
			return result.firstChild.nodeValue;
		}
	} else {
		return "n/a";
	}
}

//set up the info an Done buttons
function setup() { 
	document.getElementById('categs').onchange = function() {
		//clearTimeout(myTimer);
		widget.setPreferenceForKey(this.selectedIndex, "newsFeed");
		load();
	}
	//link to my website
	document.getElementById('designInfo').getElementsByTagName('span')[0].onclick = function() {
		clicked('http://www.nigelcrawley.co.uk/');
	}
	//link to my BBC Backstage website
	document.getElementById('designInfo').getElementsByTagName('span')[1].onclick = function() {
		clicked('http://backstage.bbc.co.uk/');
	}
	gDoneButton = new AppleGlassButton(document.getElementById("doneButton"), "Done", hidePrefs); 
	gInfoButton = new AppleInfoButton(document.getElementById("infoButton"), document.getElementById("front"), "white", "white", showPrefs); 
} 

//Set up the scroll area and scrollbar then run the show function
function load() {
	if (!window.widget) {
		show();
	} else {
		show();
	}
}

//Flip the Widget to show the preferences
function showPrefs() {
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	if (window.widget) widget.prepareForTransition("ToBack");
	front.style.display="none";
	back.style.display="block";
	if (window.widget) setTimeout ('widget.performTransition();', 0);
}

//Flip the Widget to show the front
function hidePrefs() {
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	if (window.widget) widget.prepareForTransition("ToFront");
	back.style.display="none";
	front.style.display="block";
	if (window.widget) setTimeout ('widget.performTransition();', 0);
}

//Run the functions when the Dashboard is shown or hidden
if (window.widget) {
	widget.onshow = function() {
		document.getElementById('categs').selectedIndex = widget.preferenceForKey("newsFeed");
		show();
	}
	widget.onhide = onhide;
}

//Clear the Widget's RSS content when the Dashboard is hidden
function onhide() {
	 clearTimeout(myTimer);
}

//Open the post in browser
function clicked(theURL) {
	if (window.widget) {
		widget.openURL(theURL);
	}
}

//WINDOW LOAD FUNCTION
window.onload = function() {
	load();
	setup();
}

